%define major 2
%define	libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d

%bcond_without pcre
%bcond_without png
%bcond_without onig

Summary:	The shared library for the S-Lang extension language
Name:		slang
Version:	2.3.2
Release:	%mkrel 1
License:	GPLv2+
Group:		System/Libraries
URL:		http://jedsoft.org/slang/
Source0:	http://www.jedsoft.org/releases/%{name}/%{name}-%{version}.tar.xz
Source1:	http://www.jedsoft.org/releases/%{name}/%{name}-%{version}.tar.bz2.asc
Patch1:		slang-makefile.patch
Patch2:		slang-sighuptest.patch
Patch3:		slang-getkey-memmove.patch
Patch4:		slang-SLANG_LIB_FOR_MODULES.diff
BuildRequires:	glibc-devel
%if %{with png}
BuildRequires:	libpng-devel
%endif
BuildRequires:	libtool
%if %{with pcre}
BuildRequires:	pcre-devel
%endif
%if %{with onig}
BuildRequires:	onig-devel
%endif
BuildConflicts:	slang-devel

%description
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.

%package -n %{libname}
Summary:	The shared library for the S-Lang extension language
Group:		System/Libraries
Provides:	slang

%description -n	%{libname}
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.

%package -n %{develname}
Summary:	The library and header files for development using S-Lang
Group:		Development/Libraries
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Obsoletes:	%{_lib}slang-static-devel

%description -n	%{develname}
This package contains the S-Lang extension language libraries and
header files which you'll need if you want to develop S-Lang based
applications.  Documentation which may help you write S-Lang based
applications is also included.

Install the slang-devel package if you want to develop applications
based on the S-Lang extension language.

%package doc
Summary:	Extra documentation for slang libraries
Group:		Documentation

%description doc
This package contains documentation about S-Lang.
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.

%package slsh
Summary:	S-Lang script interpreter
Group:		Shells
Provides:	%{_bindir}/slsh

%description slsh
slsh is a program that embeds the S-Lang interpreter and may be used
to test slang scripts.

%prep
%setup -q
%apply_patches

# fix permissions of installed modules
sed -i '/^INSTALL_MODULE=/s/_DATA//' configure

# disable test failing on 32-bit archs
sed -i '/TEST_SCRIPTS_SLC = /s/array //' src/test/Makefile

%build
%configure2_5x \
	--includedir=%{_includedir}/slang \
	--with-zlib=%{_libdir} --with-zinc=%{_includedir} \
	%{?with_onig:--with-oniginc=%{_includedir} --with-oniglib=%{_libdir}} \
	%{?with_png:--with-pnginc=%{_includedir} --with-pnglib=%{_libdir}} \
	%{?with_pcre:--with-pcreinc=%{_includedir} --with-pcrelib=%{_libdir}}
%make_build elf

%install
rm -rf %buildroot
%make_install

# Remove unwanted files
%if %{without pcre}
rm -f %{buildroot}%{_libdir}/slang/v%{major}/modules/pcre-module.so
%endif

%if %{without png}
rm -f %{buildroot}%{_libdir}/slang/v%{major}/modules/png-module.so
%endif

%if %{without onig}
rm -f %{buildroot}%{_libdir}/slang/v%{major}/modules/onig-module.so
%endif

%files -n %{libname}
%{_libdir}/libslang.so.%{major}*
%dir %{_libdir}/slang
%{_libdir}/slang/v%{major}

%files -n %{develname}
%{_libdir}/libslang.so
%dir %{_includedir}/slang/
%{_includedir}/slang/*.h
%{_libdir}/pkgconfig/slang.pc

%files doc
%{_defaultdocdir}/slang

%files slsh
%doc %{_docdir}/slsh
%{_bindir}/slsh
%{_datadir}/slsh
%{_mandir}/man1/slsh.1*
%config %{_sysconfdir}/slsh.rc


%changelog
* Fri Oct 14 2022 tex - 2.3.2-1pclos2022
- update
